//
//	$Date: 2003/08/15 02:52:07 $
//	$Revision: 1.10 $
//
//	QPocket Version 0.5.2
//

#include <PalmOS.h>
//#include <SonyCLIE.h>
#include <SonyChars.h>

//#define vchrJogPushedUp			(0x1703)
//#define vchrJogPushedDown		(0x1704)

#include "DropModule.h" // Drag&Drop⥸塼ѥإå

//#define OLDDRAGANDDROP	// 0.2.2ǥåץܡɷͳǸѥϤƤ

#include "id.h"
#include "acsearch.h"
#include "linkaction.h"

static void CreateNewRecordAndJump();
static void SetPreferences();

// Inline POBoxʤ
#define DICTYPE 'EDIC'
#define LDICTYPE 'LDIC'
#define POBOXCREATOR 'PBIN'
DmOpenRef dic;                // POBoxInline 
DmOpenRef ldic;               // ؽñDB

#define MAXEXTRA 0x100
unsigned char extra[MAXEXTRA];
int nextra;

LocalID memodbid;
LocalID memoappid;
unsigned short memodbcardno;
unsigned short memoappcardno;

enum {
	NEWSEARCH=1,
	NEXTSEARCH,
	PREVSEARCH
};

#define MAXLINES 12
#define MAXMATCHEDRECORDS 3000
int *memorecord;			// ޥå쥳ֹΥꥹ
int *memorecordpos;			// ޥå

int nmatchedrecords;			// η̥ޥå쥳ɤο (ޤ)
int dispindex;				// ɽϥǥ
Boolean searchisdone = false;		// 쥳ɤθλ

Boolean jogpressed = false;

void SearchInit();			//  - ˸򳫻Ϥ
void SearchMemo();			// dispindex1ڡʬmemorecord[]˳Ǽ
void Display();				// dispindex1ڡʬɽ 
void LaunchMemo(int recordno, int pos);

char defaultsearchpat[4][16];
char initsearchpat[16];

typedef struct {
	char searchpat[16];
	char memo[5];
	int movetop;
	int usetimestamp;
} QPPref;
QPPref pref;

FieldPtr patfield;            // ѥե

static unsigned long StringToLong(char *s)
{
	unsigned long val = 0;
	int i;
	for(i=0;i<4;i++){
		val = ((val << 8) + s[i]);
	}
	return val;
}

static char timestr[30];
static char *TimeStamp()
{
	long t;
	DateTimeType datetime;

	t = TimGetSeconds();
	TimSecondsToDateTime(t,&datetime);
	StrPrintF(timestr,"%4d/%02d/%02d %02d:%02d:%02d\n\000",
		  datetime.year,datetime.month,datetime.day,
		  datetime.hour,datetime.minute,datetime.second);
	return timestr;
}

static WinHandle DrawIndicator(int sel, WinHandle savedBits, int draw)
{
	UInt16 i;
	UInt16 err;
	WinHandle winH = 0;
	RectangleType indrect;
	CustomPatternType pattern;
	CustomPatternType savedPattern;

	if(sel-dispindex >= MAXLINES) return NULL; // without this, fatal error!!
	RctSetRectangle(&indrect,2,(sel-dispindex)*10+31+9,152,2);

	if(draw){
		WinGetPattern (&savedPattern);
		for(i=0;i<sizeof(CustomPatternType)/sizeof(*pattern);i++){
//			pattern[i]= 0xAA55;
//			pattern[i]= 0xAAAA;
			pattern[i]= 0xAA;
		}
		WinSetPattern((const CustomPatternType*)(&pattern));
		winH = WinSaveBits(&indrect,&err);
		WinFillRectangle (&indrect, 0);
		WinSetPattern (&savedPattern);
	}
	else {
if(savedBits)
		WinRestoreBits(savedBits,indrect.topLeft.x,indrect.topLeft.y);
	}
	return winH;
}

static int CreateNewRecord(int oldrecord)
{
	DmOpenRef memo;
	MemHandle h,hnew;
	int nrecords;
	UInt32 size,datasize;
	char *s0, *snew;
	UInt16 at;
	Err err;
	UInt16 attr;
	char c;

	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
	nrecords = DmNumRecords(memo);
	h = DmQueryRecord(memo,oldrecord);
	if(h && (s0 = MemHandleLock(h))){
		DmRecordInfo(memo,oldrecord,&attr,NULL,NULL);
		size = MemPtrSize(s0);
		datasize = size;
		if(pref.usetimestamp){
			// ॹפϰʲΤ褦ʷǥǡκǸˤĤƤ롣
			// ....\n2003/08/15 00:37:22 \n\0
			//
			// Ťॹ׾򥹥å
			datasize = size;
			for(;datasize>0;datasize--){
				c = s0[datasize-1];
				if(c != '\0' && c != ' ' && c != '\n') break;
			}
			for(;datasize>0;datasize--){
				c = s0[datasize-1];
				if(c != '\0' && c != ' ' && c != '\n' &&
				   c != '/' && c != ':' && (c < '0' || c > '9')) break;
			}
			size = datasize + 1 + StrLen(TimeStamp()) + 1;
		}
		at = nrecords;
		hnew = DmNewRecord(memo,&at,size);
		if(hnew && (snew = MemHandleLock(hnew))){
			err = DmWrite(snew,0,s0,datasize);
			if(pref.usetimestamp){
				err = DmWrite(snew,datasize,"\n",1);
				err = DmWrite(snew,datasize+1,TimeStamp(),StrLen(TimeStamp())+1);
			}
			ErrFatalDisplayIf(err,"DmWrite");
			MemHandleUnlock(hnew);
			DmReleaseRecord(memo,at,true);
			DmSetRecordInfo(memo,at,&attr,NULL);
		}
		else {
			at = -1;
		}
		MemHandleUnlock(h);
	}
	else {
		at = -1;
	}
	DmCloseDatabase(memo);
	return at;
}

static void MoveRecord(int from, int to)
{
	DmOpenRef memo;
	int nrecords;
	int newrecordno;

	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
	nrecords = DmNumRecords(memo);

	if(to < 0){
		newrecordno = nrecords/*-1*/;
	}
	else {
		newrecordno = memorecord[to];
	}

	DmMoveRecord(memo,memorecord[from],newrecordno);

	DmCloseDatabase(memo);

	SearchInit();
	SearchMemo();
	Display();
}

static Boolean SelectMemo(EventPtr e)
{
	short x,y;
	Boolean pendown = true;
	Boolean moving = false;
	RectangleType selrect;
	int sel,newsel,origrecord;
	WinHandle w;
	int recordno;
	int dispmax;
	int origsel;
	int indpos;

	dispmax = dispindex + MAXLINES;
	if(dispmax > nmatchedrecords) dispmax = nmatchedrecords;

	sel = dispindex + (e->screenY / 10 - 3);

	if(sel < dispindex || sel >= dispmax) return false;

	origsel = sel;
	origrecord = memorecord[origsel];

	RctSetRectangle(&selrect,0,(sel-dispindex)*10+31,156,10);
	WinInvertRectangle(&selrect,0);

	while(true){
		EvtGetPen(&x,&y,&pendown);
		if(!pendown) break;

		newsel = dispindex + (y / 10 - 3);
		if(dispindex - newsel > 1){ // 
			if(!moving){
				moving = true;
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
			if(dispindex > 0){
				w = DrawIndicator(indpos,w,false);

				dispindex--;
				Display();

				if(origsel >= dispindex && origsel < dispmax){
					RctSetRectangle(&selrect,0,(origsel-dispindex)*10+31,156,10);
					WinInvertRectangle(&selrect,0);
				}

				w = DrawIndicator(dispindex-1,NULL,true);
				indpos = dispindex-1;
			}
		}
		else if(newsel - dispmax >= 0){ // 她
			if(!moving){
				moving = true;
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
			if(dispindex < nmatchedrecords-1){
				w = DrawIndicator(indpos,w,false);

				dispindex++;
				SearchMemo();

				Display();

				if(origsel >= dispindex && origsel < dispmax){
					RctSetRectangle(&selrect,0,(origsel-dispindex)*10+31,156,10);
					WinInvertRectangle(&selrect,0);
				}

				w = DrawIndicator(dispmax,NULL,true);
				indpos = dispmax;
			}
		}
		else if(newsel != sel){
			if(moving){
				w = DrawIndicator(indpos,w,false);
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
			else {
				moving = true;
				sel = newsel;
				w = DrawIndicator(sel,NULL,true);
				indpos = sel;
			}
		}
		dispmax = dispindex + MAXLINES;
		if(dispmax > nmatchedrecords) dispmax = nmatchedrecords;

		sel = newsel;

	}
	if(moving){
		w = DrawIndicator(indpos,w,false);
	}

	if(origsel >= dispindex && origsel < dispmax){
		RctSetRectangle(&selrect,0,(origsel-dispindex)*10+31,156,10);
		WinInvertRectangle(&selrect,0);
	}
//	WinInvertRectangle(&selrect,0);

	if(moving){
		if(sel != origsel){
			MoveRecord(origsel,sel);
		}
	}
	else {
		recordno = memorecord[sel];
		if(x - e->screenX > 10){ // Copy existing data and make another
			recordno = CreateNewRecord(recordno);
			SearchInit();
			SearchMemo();
			Display();
		}
		else if(recordno >= 0){ // normal
			DmOpenRef memo;
			int n;
			UInt16 attr;
			if(pref.movetop){
				memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
				n = DmNumRecords(memo);
//				DmMoveRecord(memo,recordno,n-1);
				DmMoveRecord(memo,recordno,n);
				// ֹˤȰưʤȤ褦ʤΤ
				// ǿΥ쥳ɤ˥פ
//				for(n--;n>=0;n--){
				for(;n>=0;n--){
					if(DmQueryRecord(memo,n)){
						DmRecordInfo(memo,n,&attr,NULL,NULL);
						if((attr & dmRecAttrDelete) || attr & dmRecAttrSecret)
							continue;
						else
							break;
					}
				}
				DmCloseDatabase(memo);
				if(n >= 0) LaunchMemo(n,memorecordpos[sel]);
			}
			else {
				LaunchMemo(recordno,memorecordpos[sel]);
			}
		}
	}

	return true;
}

static Boolean MainFormEvent(EventPtr e)
{
	Boolean handled = true;
	UInt16 c;
	int i;
	RectangleType r;

	switch(e->eType){
	case fldChangedEvent:
		dispindex = 0;
		SearchInit();
		SearchMemo();
		Display();
		break;
	case keyDownEvent:
		c = e->data.keyDown.chr;
		if(c == 0x0503){
			// TungstenCǤ5WayϤʤȤΥɤФ
		}
		else {
			if(c >= 0x20 && c < 0x80){
				char cc = (char)c;
				FldInsert(patfield,&cc,1);
			}
			else {
				FldHandleEvent(patfield,e);
			}
			dispindex = 0;
			SearchInit();
			SearchMemo();
			Display();
		}
		break;
	case penDownEvent:
		if(e->screenY > 30){
			handled = SelectMemo(e);
		}
		else {
			handled = false;
		}
		break;
	default:
		handled = false;
		break;
	}
	return handled;
}

static Boolean ApplicationHandleEvent(EventPtr e)
{
	Boolean handled = true;
	FormPtr frm;
	UInt16 idx;
	UInt16 c;
	char *s;
	int i;
	int len;

	switch(e->eType){
	case ctlSelectEvent:
		c = e->data.ctlSelect.controlID;
		if(c == ID_BUTTON_NEW){
			CreateNewRecordAndJump();
		}
		break;
	case keyDownEvent:
		switch(c = e->data.keyDown.chr){
		case hard1Chr:
		case hard2Chr:
		case hard3Chr:
		case hard4Chr:
			i = c - hard1Chr;
			if(StrCompare(defaultsearchpat[i],"*scrollup*")==0){
				EvtEnqueueKey(vchrJogUp,0,0);
			}
			else if(StrCompare(defaultsearchpat[i],"*scrolldown*")==0){
				EvtEnqueueKey(vchrJogDown,0,0);
			}
			else if(StrCompare(defaultsearchpat[i],"*select*")==0){
				LaunchMemo(memorecord[dispindex],0);
			}
			else if(StrCompare(defaultsearchpat[i],"")==0){
				s = FldGetTextPtr(patfield);
				if(s == NULL) s = "";
				if(StrLen(s)==0){
					FldInsert(patfield,initsearchpat,StrLen(initsearchpat));
				}
				else {
					len = StrLen(s);
					if(len > 15) len = 15;
					StrNCopy(initsearchpat,s,len);
					initsearchpat[len] = '\0';
//					StrCopy(initsearchpat,s);
					FldDelete(patfield,0,StrLen(s));
				}
				handled = false;
			}
			else {
				s = FldGetTextPtr(patfield);
				if(s == NULL) s = "";
				if(StrCompare(s,defaultsearchpat[i])==0){
					FldDelete(patfield,0,StrLen(s));
				}
				else {
					FldDelete(patfield,0,StrLen(s));
					FldInsert(patfield,defaultsearchpat[i],StrLen(defaultsearchpat[i]));
				}
			}
			break;
		case vchrJogPushedUp:
			jogpressed = false;
		case pageUpChr:
			dispindex -= MAXLINES;
			if(dispindex < 0) dispindex = 0;
			Display();
			break;
		case vchrJogPushedDown:
			jogpressed = false;
		case pageDownChr:
			if(searchisdone && dispindex+MAXLINES >= nmatchedrecords) break;
			dispindex += MAXLINES;
			SearchMemo();
			Display();
			break;
		case vchrJogPress:
			jogpressed = true;
			break;
		case vchrJogRelease:
			if(jogpressed){
				LaunchMemo(memorecord[dispindex],0);
			}
			break;
		case vchrJogUp:
			if(dispindex > 0) dispindex--;
			Display();
			break;
		case vchrJogDown:
			if(dispindex < nmatchedrecords-1){
				dispindex++;
				SearchMemo();
			}
			Display();
			break;
		default:
			if(c >= 0x100) handled = true;
			handled = false;
		}
		break;
	case frmLoadEvent:
		frm = FrmInitForm(e->data.frmLoad.formID);
		ErrFatalDisplayIf(frm==NULL,"Null FormPtr");
	        FrmSetActiveForm(frm);
		FrmSetEventHandler(frm, MainFormEvent);

		idx = FrmGetObjectIndex(frm,ID_PATFIELD);
		FrmSetFocus(frm,idx);
		patfield = FrmGetObjectPtr(frm,idx);

	        break;
	case frmOpenEvent:
        	FrmDrawForm(FrmGetActiveForm());

		ErrFatalDisplayIf(patfield==NULL,"Null PatField");
		FldInsert(patfield,pref.searchpat,StrLen(pref.searchpat));
		/*
		{
			Char buf[100];
			FormPtr frm;
			UInt32 d;
			int i;
			frm = FrmGetActiveForm();
			d = (UInt32)frm;
			StrCopy(buf,"                 ");
			for(i=0;i<8;i++){
				int j;
				j = ((d >> ((7-i)*4)) & 0xf);
				buf[i] = (j > 9 ? j+'a'-10 : j+'0');
			}
			buf[i] = '\0';
			WinDrawChars(buf,StrLen(buf),40,10);
		}
		*/
		if(StrLen(pref.searchpat)==0){
			dispindex = 0;
			SearchInit();
			SearchMemo();
			Display();
		}

	        break;
	case menuEvent:
		switch(e->data.menu.itemID){
		case ID_MENU_UNDO:		FldUndo(patfield);			break;
		case ID_MENU_CUT:		FldCut(patfield);			break;
		case ID_MENU_PASTE:		FldPaste(patfield);			break;
		case ID_MENU_COPY:		FldCopy(patfield);			break;
		case ID_MENU_ABOUTHELP:		FrmHelp(ID_ABOUTHELP_STRING);		break;
		case ID_MENU_SEARCHHELP:	FrmHelp(ID_SEARCHHELP_STRING);		break;
		case ID_MENU_MOVEHELP:		FrmHelp(ID_MOVEHELP_STRING);		break;
		case ID_MENU_ADDHELP:		FrmHelp(ID_ADDHELP_STRING);		break;
		case ID_MENU_VERSION:		FrmAlert(ID_ALERT_ABOUTQPOCKET);	break;
		case ID_MENU_PREFERENCES:	SetPreferences();			break;
		default:								break;
		}
		break;
	default:
		handled = false;
		break;
	}
	return handled;
}

void StartApplication()
{
	int i,j;
	UInt16 prefsize;
	DmOpenRef memo;
	int nrecords;
	MemHandle h;
	char *s0,*s,*p;
	Boolean found = false;
	UInt16 length;

	FrmGotoForm(ID_MAINFORM);

	prefsize = sizeof(QPPref);
	if(PrefGetAppPreferences(CREATOR,0,&pref,&prefsize,true) == noPreferenceFound){
		// ErrFatalDisplayIf(true,"Can't open Pref DB");
		StrCopy(pref.searchpat,"");
		StrCopy(pref.memo,"memo");
		pref.movetop = 0;
		pref.usetimestamp = 0;
		PrefSetAppPreferences(CREATOR,0,1,&pref,sizeof(QPPref),true);
	}
//	StrCopy(initsearchpat,pref.searchpat);

#ifdef OLDDRAGANDDROP
	// åץܡʸ󤬤Ф򸡺ʸˤƤ (0.2.2)
	h = ClipboardGetItem(clipboardText,&length);
	if(length > 0){
		if(length > 15) length = 15;
		s = MemHandleLock(h);
		StrNCopy(pref.searchpat,s,length);
		pref.searchpat[length] = '\0';
		MemHandleUnlock(h);
		ClipboardAddItem(clipboardText,"",0);
	}
#endif

	// POBox񥪡ץ / dic/ldicϥ̥ǤOK
	ldic = DmOpenDatabaseByTypeCreator(LDICTYPE,POBOXCREATOR,dmModeReadOnly);
	dic = DmOpenDatabaseByTypeCreator(DICTYPE,POBOXCREATOR,dmModeReadOnly);
	// ErrFatalDisplayIf(dic==NULL,"Can't open PBInline DB");
	if(dic){
		//
		//	ĥοƬʸĴ
		//
		nextra = DmNumRecords(dic) - 0xa00;
		if(nextra > MAXEXTRA) nextra = MAXEXTRA;
		for(i=0;i< nextra;i++){
			unsigned char *s0;
			MemHandle h;
			h = DmQueryRecord(dic,0xa00+i);
			ErrFatalDisplayIf(h==NULL,"Can't open extra dictionary area");
			s0 = MemHandleLock(h);
			extra[i] = *s0;
			MemHandleUnlock(h);
		}
	}

	//
	//	Graffiti Shift Indicator
	// 	
	GsiSetLocation(143,15);
	GsiEnable(false);

	for(i=0;i<4;i++){
		defaultsearchpat[i][0] = '\0';
	}

#define QPPATID "QPocketPattern\n"
	//
	// Ģǡ١ץ
	//
	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadOnly);
	ErrFatalDisplayIf(memo==NULL,"No memo DB");

	nrecords = DmNumRecords(memo);
	for(i=0;i<nrecords && !found;i++){
		h = DmQueryRecord(memo,i);
		if(h && (s0 = MemHandleLock(h))){
			int size = MemPtrSize(s0);
			if(size >= StrLen(QPPATID) && StrNCompare(s0,QPPATID,StrLen(QPPATID))==0){
				found = true;
				s = s0 + StrLen(QPPATID);
				for(j=0;j<4;j++){
					p = defaultsearchpat[j];
					while(*s != '\n' && s-s0 < size) *p++ = *s++;
					*p = '\0';
					s++;
				}
			}
			MemHandleUnlock(h);
		}
	}
	DmCloseDatabase(memo);

	memorecord = (int*)MemPtrNew(sizeof(int) * MAXMATCHEDRECORDS);
	memorecordpos = (int*)MemPtrNew(sizeof(int) * MAXMATCHEDRECORDS);
}

void StopApplication()
{
	char *s = FldGetTextPtr(patfield);
	int len;
	FormPtr frm;

	if(s){
		len = FldGetTextLength(patfield);
		if(len > 15) len = 15;
	}
	else {
		s = "";
		len = 0;
	}
	StrNCopy(pref.searchpat,s,len);
	pref.searchpat[len] = '\0';
	PrefSetAppPreferences(CREATOR,0,1,&pref,sizeof(QPPref),true);

	if(dic) DmCloseDatabase(dic);
	if(ldic) DmCloseDatabase(ldic);

	// PalmOS5.0ǤϡʲʤHomeȤȤFatalErrorˤʤäƤޤ 2003/6/4
	frm = FrmGetActiveForm();
	FrmEraseForm(frm);
	FrmDeleteForm(frm);

	if(memorecord) MemPtrFree(memorecord);
	if(memorecordpos) MemPtrFree(memorecordpos);
}

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	EventType event;
	UInt16 error;
	tDropLaunchCmdParamPtr param;
	LocalID appid;
	unsigned short appcardno;
	DmSearchStateType state;

	QPPref pref;
	UInt16 prefsize;
	int len;

	switch(cmd){
	case sysAppLaunchCmdNormalLaunch:
		StartApplication();
		do {
			EvtGetEvent(&event, evtWaitForever);
			if (ApplicationHandleEvent(&event)) continue;
			if (SysHandleEvent(&event)) continue;
			if (MenuHandleEvent(NULL, &event, &error)) continue;
			FrmDispatchEvent(&event);
		}
		while (event.eType != appStopEvent);
		StopApplication();
		return 0;

	case dDropLaunchSupportCmd: // D&D⥸塼븡ΤȤ
		return dYes_Support;
	case dDropLaunchCmd: // D&D⥸塼ƤӽФ
		param = (tDropLaunchCmdParamPtr)cmdPBP;
#ifdef OLDDRAGANDDROP
		//: ԡХåե˸ʸǼƼʬƤӸƤ֤褦ˤʤäƤ
		ClipboardAddItem(clipboardText,param->srcText,param->srcTextLength);
		DmGetNextDatabaseByTypeCreator(true,&state,'appl',CREATOR,false,&appcardno,&appid);
		SysUIAppSwitch(appcardno,appid,sysAppLaunchCmdNormalLaunch,NULL);
#else
		// ѿprefȤFatalErrorˤʤΤ
		prefsize = sizeof(QPPref);
		if(PrefGetAppPreferences(CREATOR,0,&pref,&prefsize,true) == noPreferenceFound){
			// ErrFatalDisplayIf(true,"Can't open Pref DB");
			StrCopy(pref.searchpat,"");
			StrCopy(pref.memo,"memo");
			pref.movetop = 0;
			pref.usetimestamp = 0;
		}
		len = param->srcTextLength;
		if(len > 15) len = 15;
		StrNCopy(pref.searchpat,param->srcText,len);
		pref.searchpat[len] = '\0';
		PrefSetAppPreferences(CREATOR,0,1,&pref,sizeof(QPPref),true);

//		param->resultBehavior = eBehavior_LaunchMe;  Fatal Errorˤʤ!!

		DmGetNextDatabaseByTypeCreator(true,&state,'appl',CREATOR,false,&appcardno,&appid);
		SysUIAppSwitch(appcardno,appid,sysAppLaunchCmdNormalLaunch,NULL);
#endif
		return 0;
	default:
		return 0;
	}
}

void SearchInit()
{
	nmatchedrecords = 0;
	searchisdone = false;
}

void SearchMemo()		// dispindex1ڡʬmemorecord[]˳Ǽ
{
	int n,i;
	DmOpenRef memo;
	MemHandle h;
	int nrecords;
	unsigned char *pat,*s,*s0;
	int startrecord;
	int size;
	int matchpos;
	UInt16 attr;
	int len;
	UInt32 hide;

	// ˸ߤʤ鲿⤷ʤ
	if(searchisdone) return;
	if(dispindex+MAXLINES <= nmatchedrecords) return;

	//
	// Ģǡ١򥪡ץ󤷤nmatchedrecordsʹdispindex+MAXLINESޤǤ򸡺
	//
	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadOnly);
	if(memo == NULL) return;

	if(pat = FldGetTextPtr(patfield)){
		len = FldGetTextLength(patfield);
	}
	else {
		pat = "";
		len = 0;
	}
	if(len > 15) len = 15;
/*
pat = FldGetTextPtr(patfield);
if(!pat) pat = "";
len = StrLen(pat);
if(len > 15) len = 15;
*/

	StrNCopy(pref.searchpat,pat,len);
	pref.searchpat[len] = '\0';

	// ٤ʣϤä縡å
	if(!EvtKeyQueueEmpty()){
		DmCloseDatabase(memo);
		return;
	}

	MakeSearchPat(pref.searchpat);

	hide = PrefGetPreference(prefHidePrivateRecordsV33);

	nrecords = DmNumRecords(memo);
	if(nmatchedrecords == 0){
		startrecord = nrecords - 1;
	}
	else {
		startrecord = memorecord[nmatchedrecords-1]-1;
	}
	for(n=startrecord;
		nmatchedrecords < dispindex+MAXLINES &&
		nmatchedrecords < MAXMATCHEDRECORDS && n >= 0;n--){
		DmRecordInfo(memo,n,&attr,NULL,NULL);
		if((attr & dmRecAttrDelete) || ((attr & dmRecAttrSecret) && hide))
//		if((attr & dmRecAttrDelete) || (attr & dmRecAttrSecret))
			continue;
		h = DmQueryRecord(memo,n);
		if(h && (s0 = MemHandleLock(h))){
			size = MemPtrSize(s0);
			if(*pat == NULL){
				memorecord[nmatchedrecords] = n;
				memorecordpos[nmatchedrecords] = 0;
				nmatchedrecords++;
			}
			else if((matchpos = acsearch_match_size(s0,size)) >= 0){
				memorecord[nmatchedrecords] = n;
				memorecordpos[nmatchedrecords] = matchpos;
				nmatchedrecords++;
			}
			MemHandleUnlock(h);
		}
	}
	if(n < 0)
		searchisdone = true;

	DmCloseDatabase(memo);
}

void Display()
{
	DmOpenRef memo;
	MemHandle h;
	unsigned char *s,*s0;
	int i,l;
	int size;
	RectangleType r;

	// ˸ߤʤ鲿⤷ʤ
//	if(searchisdone) return;
//	if(dispindex+MAXLINES <= nmatchedrecords) return;

	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadOnly);
	if(memo == NULL) return;

	RctSetRectangle(&r,0,28,156,128);
	WinEraseRectangle(&r,0);

	for(i=dispindex,l=0;i<nmatchedrecords && l<MAXLINES;i++,l++){
		h = DmQueryRecord(memo,memorecord[i]);
		if(h && (s0 = MemHandleLock(h))){
			size = MemPtrSize(s0);
			s = s0;
			while(*s != '\n' && s-s0 < size) s++;
			WinDrawChars(s0,s-s0,3,l*10+30);
			MemHandleUnlock(h);
		}
	}
	DmCloseDatabase(memo);
}

//
//	Search POBox dictionaries and make the transition table.
//
MakeSearchPat(char *pat)
{
	register unsigned char *s,*p;
	DmOpenRef ds;
	int havespace = 0;
	int resid;
	MemHandle h;

	if(pat == NULL || *pat == NULL) return;

	acsearch_beginpat();
	acsearch_addpat(pat);

	if(dic){
		//
		// ñ켭/ĥñ켭δޥå
		//
		resid = (int)(*pat);

		ds = (resid < 0x100 && ldic ? ldic : dic);

		while(havespace == 0 && resid){
			h = DmQueryRecord(ds,resid);
			if(h && (s = MemHandleLock(h))){
				while(*s){ // DBκǸNULL
					for(p = pat;*p && *p == *s; p++,s++);
					if(*p == '\0'){
						for(;*s && *s != '\002';s++);
						s++;
						havespace = acsearch_addpat(s);
						if(havespace != 0){
							break;
						}
					}
					for(;*s;s++);
					s++;
				}
				MemHandleUnlock(h);
			}
			//
			// ñ켭򤵤
			//
			resid = NextDictRecord(resid,(int)(*pat));
			ds = dic;
		}
	}
	acsearch_endpat();
}

int
NextDictRecord(int resid, int c)
{
	if(resid == c){
		resid = 0xa00;
	}
	else {
		resid++;
	}
	for(;resid < 0xa00 + nextra;resid++){
		if(extra[resid - 0xa00] == c) return resid;
	}
	return 0;
}

void
LaunchMemo(int recordno, int pos)
{
	GoToParamsType *cmdPBP;
	DmSearchStateType state;

	LinkAction(LINKJUMP);

	cmdPBP = (GoToParamsType*)MemPtrNew(sizeof(GoToParamsType));
	DmGetNextDatabaseByTypeCreator(true,&state,'appl',
		StringToLong(pref.memo),false,&memoappcardno,&memoappid);
	DmGetNextDatabaseByTypeCreator(true,&state,'DATA',
		'memo',false,&memodbcardno,&memodbid);
	cmdPBP->searchStrLen = 0;
	cmdPBP->dbCardNo = memodbcardno;
	cmdPBP->dbID = memodbid;
	cmdPBP->recordNum = recordno;
	cmdPBP->matchPos = pos;
	cmdPBP->matchFieldNum = 0; 
	cmdPBP->matchCustom = 0;
	MemPtrSetOwner((MemPtr)cmdPBP,0);
	SysUIAppSwitch(memoappcardno,memoappid,sysAppLaunchCmdGoTo,(MemPtr)cmdPBP);
}

static void
CreateNewRecordAndJump()
{
	DmOpenRef memo;
	MemHandle h,hnew;
	UInt16 nrecords;
	UInt32 size;
	char *newdata, *snew;

	Err err;
	UInt16 attr;

	memo = DmOpenDatabaseByTypeCreator('DATA','memo',dmModeReadWrite);
	nrecords = DmNumRecords(memo);
	newdata = (pref.usetimestamp ? TimeStamp() : "\000");
	h = DmNewRecord(memo,&nrecords,StrLen(newdata)+1);
	if(h){
		GoToParamsType *cmdPBP;
		DmSearchStateType state;

		if(snew = MemHandleLock(h)){
			err = DmWrite(snew,0,newdata,StrLen(newdata)+1);
			ErrFatalDisplayIf(err,"DmWrite");
			MemHandleUnlock(h);
		}
		DmReleaseRecord(memo,nrecords,true);

		cmdPBP = (GoToParamsType*)MemPtrNew(sizeof(GoToParamsType));
		DmGetNextDatabaseByTypeCreator(true,&state,'appl',
			StringToLong(pref.memo),false,&memoappcardno,&memoappid);
		cmdPBP->searchStrLen = 0;
		cmdPBP->dbCardNo = memodbcardno;
		cmdPBP->dbID = memodbid;
		cmdPBP->recordNum = nrecords;
		cmdPBP->matchPos = 0;
		cmdPBP->matchFieldNum = 0; 
		cmdPBP->matchCustom = 0;
		MemPtrSetOwner((MemPtr)cmdPBP,0);
DmCloseDatabase(memo);
		SysUIAppSwitch(memoappcardno,memoappid,sysAppLaunchCmdGoTo,(MemPtr)cmdPBP);

		EvtEnqueueKey(0x08,0,0); // Ǹβʸ(!)
	}
	else {
		DmCloseDatabase(memo);
	}
	return;
}

static MemPtr GetObjectPtr(UInt16 objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return (FrmGetObjectPtr(frm, FrmGetObjectIndex (frm, objectID)));
}

static void SetPreferences()
{
	FormPtr prefform;

	UInt16 id;
	ControlPtr movetop;
	ControlPtr usetimestamp;
	FieldPtr memo;

	prefform = FrmInitForm(ID_PREFSFORM);
	ErrFatalDisplayIf(prefform==0,"No prefform");
	FrmSetActiveForm(prefform);

	movetop = (ControlPtr)GetObjectPtr(ID_CHECKBOX_MOVETOP);
	CtlSetValue(movetop,pref.movetop ? 1 : 0);
	usetimestamp = (ControlPtr)GetObjectPtr(ID_CHECKBOX_TIMESTAMP);
	CtlSetValue(usetimestamp,pref.usetimestamp ? 1 : 0);
	memo = (FieldPtr)GetObjectPtr(ID_FIELD_MEMO);
	FldInsert(memo,pref.memo,StrLen(pref.memo));

	FrmDrawForm(prefform);
	id = FrmDoDialog(prefform);

	if(id == ID_BUTTON_PREF_OK){
		StrCopy(pref.memo,FldGetTextPtr(memo));
		pref.movetop = CtlGetValue(movetop);
		pref.usetimestamp = CtlGetValue(usetimestamp);
		PrefSetAppPreferences(CREATOR,0,1,&pref,sizeof(QPPref),true);
	}

	FrmReturnToForm(NULL);
}


